#ifndef _MXNET2API_H
#define _MXNET2API_H


#if defined _WIN32 || defined _WIN64
    #define WINAPI __stdcall
#else
    #define WINAPI
#endif


#ifdef __cplusplus
#include <cstdint>

namespace mxnet2 {
    extern "C" {
#else

#include <stdint.h>

#endif


        int16_t  WINAPI rInit_MatrixAPI(void);
        int16_t  WINAPI rRelease_MatrixAPI(void);
        int32_t  WINAPI rGetVersionAPI(void);
        int32_t  WINAPI rGetVersionDRV(void);
        int32_t  WINAPI rGetVersionDRV_USB(void);
        int16_t  WINAPI rDongle_ReadData(int32_t, int32_t*, int16_t, int16_t, int16_t);
        int16_t  WINAPI rDongle_ReadDataEx(int32_t, int32_t*, int16_t, int16_t, int16_t, int16_t);
        int32_t  WINAPI rDongle_ReadSerNr(int32_t, int16_t, int16_t);
        int32_t  WINAPI rDongle_Version(int16_t, int16_t);
        int32_t  WINAPI rDongle_Model(int16_t, int16_t);
        int16_t  WINAPI rDongle_MemSize(int16_t, int16_t);
        int16_t  WINAPI rDongle_Count(int16_t);

        int16_t  WINAPI rSetConfig_MatrixNet(int16_t, const char*);
        int32_t  WINAPI rGetConfig_MatrixNet(int16_t Category);

        int16_t  WINAPI rLogIn_MatrixNet(int32_t, int16_t, int16_t);
        int16_t  WINAPI rLogOut_MatrixNet(int32_t, int16_t, int16_t);


        int16_t  WINAPI rDongle_GetKeyFlag(int32_t UserCode, int16_t DongleNr, int16_t PortNr);

        int16_t  WINAPI rDongle_EncryptData(int32_t UserCode, int32_t* DataBlock, int16_t DongleNr, int16_t PortNr);
        int16_t  WINAPI rDongle_DecryptData(int32_t UserCode, int32_t* DataBlock, int16_t DongleNr, int16_t PortNr);

        int16_t  WINAPI rDongle_GetDriverFlag(int32_t UserCode, int16_t DongleNr, int16_t PortNr);

#if defined _WIN32 || defined _WIN64
        const wchar_t* WINAPI MxNet_SetIP(const wchar_t*);
        const char*    WINAPI MxNet_SetIPA(const char*);
#else
        const char* WINAPI MxNet_SetIP(const char*);
#endif

        int32_t WINAPI MxNet_SetPort(int32_t);
        int32_t WINAPI MxNet_SetTimeOut(int32_t);

        int32_t WINAPI rDongle_GetDetectTime(int32_t UserCode, int32_t* timeBuffer, int16_t dNr, int16_t pNr);
        int32_t WINAPI rDongle_GetLoginCount(int32_t UserCode, int16_t appSlot, int16_t dNr, int16_t PortNr);
        int32_t WINAPI rDongle_GetLoginCountEx(int32_t UserCode, int16_t appSlot, int16_t dNr, int16_t PortNr, char** ppszClientNames);

        void  WINAPI   Reset_MatrixAPI(void);

#ifdef __cplusplus
    }
}
#endif


#endif  // _MXNET2API_H

